var LBG_object_realpos_x (LBG_WINDOW* obj)
{
	switch (obj->stype)
	{
		case 1:
		return(obj->pos_x);
		break;
		
		case 2:
		if(obj->flags & BFi_COMBOBOX) if(obj->parent->parent) return(obj->parent->parent->cpos_x + obj->pos_x - obj->parent->parent->hscrollamount + obj->parent->pos_x);
		if(!obj->parent) return(obj->pos_x);
		else if(!((obj->flags & BFi_TITLEBAR) || (obj->flags & BFi_SCROLLBAR) || (obj->flags & BFi_COMBOBOX))) return(obj->parent->cpos_x + obj->pos_x - obj->parent->hscrollamount);
		else return(obj->parent->pos_x + obj->pos_x);
		break;
		
		case 3: case 4: case 6: case 11: case 13: case 18:
		if ((obj->stype == 13) && ((obj->flags & LFi_RIGHTCLICK) || (obj->flags & LFi_COMBOBOX))) return obj->pos_x;
		if(!obj->parent) return(obj->pos_x);
		else return(obj->parent->cpos_x + obj->pos_x - obj->parent->hscrollamount);
		break;
		
		case 14:
		return(obj->panel->pos_x);
		break;
		
		
		default:
		return(obj->pos_x);
		break;
	}
}

var LBG_object_realpos_y (LBG_WINDOW* obj)
{
	switch (obj->stype)
	{
		case 1:
		return(obj->pos_y);
		break;
		
		case 2:
		if(obj->flags & BFi_COMBOBOX) if(obj->parent->parent) return(obj->parent->parent->cpos_y + obj->pos_y - obj->parent->parent->vscrollamount + obj->parent->pos_y);
		if(!obj->parent) return(obj->pos_y);
		else if(!((obj->flags & BFi_TITLEBAR) || (obj->flags & BFi_SCROLLBAR) || (obj->flags & BFi_COMBOBOX))) return(obj->parent->cpos_y + obj->pos_y - obj->parent->vscrollamount);
		else return(obj->parent->pos_y + obj->pos_y);
		break;
		
		case 3: case 4: case 6: case 11: case 13: case 18:
		if ((obj->stype == 13) && ((obj->flags & LFi_RIGHTCLICK) || (obj->flags & LFi_COMBOBOX))) return obj->pos_y;
		if(!obj->parent) return(obj->pos_y);
		else return(obj->parent->cpos_y + obj->pos_y - obj->parent->vscrollamount);
		break;
		
		case 14:
		return(obj->panel->pos_y);
		break;
		
		
		default:
		return(obj->pos_y);
		break;
	}
}

var LBG_txt_size_x (TEXT* text)
{
	if(text->size_x) return text->size_x;
	return(65535);
}
var LBG_txt_size_y (TEXT* text)
{
	if(text->size_y) return minv(text->size_y,4096);
	return text->font->dy;
}

int LBG_button_condition (LBG_BUTTON* but, void* func);
int LBG_mouse_over_object (LBG_WINDOW* obj)
{
	if((obj->stype == 2) && (obj->flags & BFi_COMBOBOX)) return (LBG_mouse_pos_x () >= ((LBG_COMBOBOX*)(obj->parent))->editbox->panel->pos_x) && (LBG_mouse_pos_x () < obj->panel->pos_x + obj->panel->size_x*obj->panel->scale_x) && (LBG_mouse_pos_y () >= obj->panel->pos_y) && (LBG_mouse_pos_y () < obj->panel->pos_y + obj->panel->size_y*obj->panel->scale_y);
	if(obj->stype == 3) return (LBG_mouse_pos_x () >= LBG_object_realpos_x(obj)) && (LBG_mouse_pos_x () < LBG_object_realpos_x(obj) + ((LBG_PANEL*)(obj))->panel->size_x) && (LBG_mouse_pos_y () >= LBG_object_realpos_y(obj)) && (LBG_mouse_pos_y () < LBG_object_realpos_y(obj) + ((LBG_PANEL*)(obj))->panel->size_y);
	if((obj->stype == 4) || (obj->stype == 17)) return (LBG_mouse_pos_x () >= LBG_object_realpos_x(obj)) && (LBG_mouse_pos_x () < LBG_object_realpos_x(obj) + LBG_txt_size_x(((LBG_TEXT*)(obj))->text)) && (LBG_mouse_pos_y () >= LBG_object_realpos_y(obj)) && (LBG_mouse_pos_y () < LBG_object_realpos_y(obj) + LBG_txt_size_y(((LBG_TEXT*)(obj))->text));
	return (LBG_mouse_pos_x () >= LBG_object_realpos_x(obj)) && (LBG_mouse_pos_x () < LBG_object_realpos_x(obj) + obj->size_x*obj->scale_x) && (LBG_mouse_pos_y () >= LBG_object_realpos_y(obj)) && (LBG_mouse_pos_y () < LBG_object_realpos_y(obj) + obj->size_y*obj->scale_y);
}


var LBG_object_ppos_x (LBG_WINDOW* obj)
{
	if(!obj->parent) return (0);
	if((obj->stype == 2) && (obj->flags & BFi_COMBOBOX)) return(LBG_object_realpos_x(((LBG_COMBOBOX*)(obj->parent))->editbox) + ((LBG_COMBOBOX*)(obj->parent))->editbox->size_x - obj->pos_x);
	if(!(((obj->flags & BFi_TITLEBAR) || (obj->flags & BFi_SCROLLBAR)) && (obj->stype == 2))) return(obj->parent->cpos_x - obj->parent->hscrollamount);
	else return(obj->parent->pos_x);
}

var LBG_object_ppos_y (LBG_WINDOW* obj)
{
	if(!obj->parent) return (0);
	if((obj->stype == 2) && (obj->flags & BFi_COMBOBOX)) return(LBG_object_realpos_y(((LBG_COMBOBOX*)(obj->parent))->editbox) - obj->pos_y);
	if(!(((obj->flags & BFi_TITLEBAR) || (obj->flags & BFi_SCROLLBAR)) && (obj->stype == 2))) return(obj->parent->cpos_y - obj->parent->vscrollamount);
	else return(obj->parent->pos_y);
}

void LBG_object_update_pos (LBG_WINDOW* obj)
{
	if ((obj->stype == 2) || (obj->stype == 3) || (obj->stype == 6) || (obj->stype == 8) || (obj->stype == 11) || (obj->stype == 18))
	{
		obj->panel->pos_x = obj->pos_x + LBG_object_ppos_x(obj);
		obj->panel->pos_y = obj->pos_y + LBG_object_ppos_y(obj);
		
		
	}
	if ((obj->stype == 2) || (obj->stype == 6) || (obj->stype == 8) || (obj->stype == 18))
	{
		obj->text->pos_x = obj->pos_x + obj->tpos_x + LBG_object_ppos_x(obj);
		obj->text->pos_y = obj->pos_y + obj->tpos_y + LBG_object_ppos_y(obj);
	}
	if ((obj->stype == 4) || (obj->stype == 17))
	{
		((LBG_TEXT*)(obj))->text->pos_x = obj->pos_x + LBG_object_ppos_x(obj);
		((LBG_TEXT*)(obj))->text->pos_y = obj->pos_y + LBG_object_ppos_y(obj);
	}
	if (obj->stype == 8)
	{
		((LBG_PROGRESSBAR*)(obj))->bar->pos_x = obj->pos_x + LBG_object_ppos_x(obj) + ((LBG_PROGRESSBAR*)(obj))->barpos_x;
		((LBG_PROGRESSBAR*)(obj))->bar->pos_y = obj->pos_y + LBG_object_ppos_y(obj) + ((LBG_PROGRESSBAR*)(obj))->barpos_y;
	}
	
	if(obj->stype == 13)
	{
		if(obj->parent)
		if((obj->parent->stype == 15) || (obj->parent->stype == 16))
		{
			obj->panel->pos_x = obj->pos_x;
			obj->panel->pos_y = obj->pos_y;
			return;
		}
		obj->panel->pos_x = obj->pos_x + LBG_object_ppos_x(obj);
		obj->panel->pos_y = obj->pos_y + LBG_object_ppos_y(obj);
	}
	
	if(obj->stype == 14)
	{
		obj->panel->pos_x = obj->pos_x;
		obj->panel->pos_y = obj->pos_y;
		obj->text->pos_x = obj->panel->pos_x + ((LBG_LISTBOX*)(obj->parent))->tpos_x;
		obj->text->pos_y = obj->panel->pos_y + ((LBG_LISTBOX*)(obj->parent))->tpos_y;
	}
	
	if(obj->stype == 17)
	{
		((LBG_DIGITS*)(obj))->text->pos_x = obj->pos_x + LBG_object_ppos_x(obj);
		((LBG_DIGITS*)(obj))->text->pos_y = obj->pos_y + LBG_object_ppos_y(obj);
	}
	
}


var LBG_window_calc_panel_layer (var wlayer);
var LBG_object_calc_panel_layer (LBG_WINDOW* obj)
{
	var layer = obj->layer*LBG_butlayer_step;
	
	
	if(obj->parent)
	{
		switch(obj->parent->stype)
		{
			case 1:
			layer += LBG_window_calc_panel_layer(obj->parent->layer)+3;
			break;
			
			case 9: case 10:
			layer += LBG_window_calc_panel_layer(obj->parent->parent->layer)+3;
			if(obj->stype == 2) layer++;
			break;
		}
		
	}
	else layer += LBG_lowest_layer+1;
	
	if(obj->parent) if((obj->parent->stype == 9) || (obj->parent->stype == 10))
	{
		layer++;
		if(obj->parent->parent) if(obj->parent->parent->stype == 13) layer+= obj->parent->panel->layer+3;
	}
	if(obj->parent) if((obj->stype == 9) || (obj->stype == 10))
	{
		if(obj->parent->stype == 13) layer+= obj->parent->panel->layer+3;
	}
	
	
	
	return(layer);
}

var LBG_object_calc_text_layer (LBG_WINDOW* obj)
{
	var layer = obj->layer*LBG_butlayer_step;
	if(obj->parent) layer += LBG_window_calc_panel_layer(obj->parent->layer)+5;
	else layer += LBG_lowest_layer+2;
	return(layer);
}

int LBG_object_update_size_sb (LBG_BUTTON* obj)
{
	if(obj->stype != 2) return 0;
	if(obj->flags & BFi_TITLEBAR) return 1;
	if(obj->flags & BFi_SCROLLBAR)
	{
		if(obj->parent)
		if((obj->parent->stype == 9) || (obj->parent->stype == 10))
		if(obj->parent->parent)
		if(obj->parent->parent->stype == 13)
		return 0;
		return 1;
	}
	else return 0;
	if(obj->flags & BFi_COMBOBOX)
	{
		if(!obj->parent->parent)
		return 1;
		return 0;
	}
}

void LBG_object_update_size (LBG_WINDOW* obj)
{
	if ((obj->stype == 2) || (obj->stype == 3) || (obj->stype == 6) || (obj->stype == 7) || (obj->stype == 8)  || (obj->stype == 9) || (obj->stype == 10) || (obj->stype == 11) || (obj->stype == 13)  || (obj->stype == 14)  || (obj->stype == 15) || (obj->stype == 18))
	{
		obj->panel->scale_x = obj->scale_x;
		obj->panel->scale_y = obj->scale_y;
	}
	
	if((!obj->parent) || LBG_object_update_size_sb(obj) || ((obj->stype == 13) && ((obj->flags & LFi_RIGHTCLICK) || (obj->flags & LFi_COMBOBOX))))
	{
		if ((obj->stype == 2) || (obj->stype == 6) || (obj->stype == 8) || (obj->stype == 11) || (obj->stype == 13) || (obj->stype == 18))
		{
			obj->panel->size_x = bmap_width(obj->panel->bmap);
			obj->panel->size_y = bmap_height(obj->panel->bmap);
		}
		else if(obj->stype == 3)
		{
			obj->panel->size_x = obj->size_x;
			obj->panel->size_y = obj->size_y;
		}
		
		if ((obj->stype == 2) || (obj->stype == 8))
		{
			obj->text->size_x = bmap_width(obj->panel->bmap)-obj->tpos_x/2;
			obj->text->size_y = bmap_height(obj->panel->bmap)-obj->tpos_y;
		}
		else if((obj->stype == 4) || (obj->stype == 17))
		{
			((LBG_TEXT*)(obj))->text->size_x = obj->size_x;
			((LBG_TEXT*)(obj))->text->size_y = obj->size_y;
		}
		else if(obj->stype == 6)
		{
			obj->text->size_x = 65535;
			obj->text->size_y = 65535;
		}
		
		
		if(obj->stype == 11)
		{
			((LBG_SLIDER*)(obj))->knob->size_x = bmap_width(((LBG_SLIDER*)(obj))->knob->bmap);
			((LBG_SLIDER*)(obj))->knob->size_y = bmap_height(((LBG_SLIDER*)(obj))->knob->bmap);
		}
		
		if(obj->stype == 18)
		{
			obj->text->size_x = bmap_width(obj->panel->bmap)-obj->tpos_x*2;
			obj->text->size_y = bmap_height(obj->panel->bmap)-obj->tpos_y;
			
			((LBG_EDITBOX*)(obj))->cursor->size_x = 65535;
			((LBG_EDITBOX*)(obj))->cursor->size_y = 65535;
		}
		
	}
	else
	{
		if((obj->stype == 2) && (obj->flags & BFi_COMBOBOX))
		{
			if(obj->parent->parent)
			{
				obj->panel->size_x = maxv(0.1,minv(bmap_width(obj->panel->bmap),obj->parent->parent->cpos_x+obj->parent->parent->csize_x-obj->panel->pos_x)+0.1);
				obj->panel->size_y = maxv(0.1,minv(bmap_height(obj->panel->bmap),obj->parent->parent->cpos_y+obj->parent->parent->csize_y-obj->panel->pos_y)+0.1);
			}
		}
		else if((obj->stype == 2) || (obj->stype == 6) || (obj->stype == 8) || (obj->stype == 11) || (obj->stype == 13) || (obj->stype == 18))
		{
			obj->panel->size_x = maxv(0.1,minv(bmap_width(obj->panel->bmap),obj->parent->cpos_x+obj->parent->csize_x-obj->panel->pos_x)+0.1);
			obj->panel->size_y = maxv(0.1,minv(bmap_height(obj->panel->bmap),obj->parent->cpos_y+obj->parent->csize_y-obj->panel->pos_y)+0.1);
			
			switch(obj->parent->stype)
			{
				case 1:
				if ((obj->panel->pos_x < obj->parent->cpos_x) || (obj->panel->pos_y < obj->parent->cpos_y)) obj->panel->size_x = 0.1;
				break;
				case 9: case 10:
				if ((obj->panel->pos_x < obj->parent->parent->cpos_x) || (obj->panel->pos_y < obj->parent->parent->cpos_y)) obj->panel->size_x = 0.1;
				
				if(obj->parent->parent) if(obj->parent->parent->stype == 13)
				{
					obj->panel->size_x = maxv(0.1,minv(bmap_width(obj->panel->bmap),((LBG_LISTBOX*)(obj->parent->parent))->panel->pos_x+((LBG_LISTBOX*)(obj->parent->parent))->panel->size_x-obj->panel->pos_x)+0.1);
					obj->panel->size_y = maxv(0.1,minv(obj->size_y,((LBG_LISTBOX*)(obj->parent->parent))->panel->pos_y+((LBG_LISTBOX*)(obj->parent->parent))->panel->size_y-obj->panel->pos_y)+0.1);
				}
				
				break;
			}
			
		}
		if(obj->stype == 3)
		{
			obj->panel->size_x = maxv(0.1,minv(obj->size_x,obj->parent->cpos_x+obj->parent->csize_x-obj->panel->pos_x)+0.1);
			obj->panel->size_y = maxv(0.1,minv(obj->size_y,obj->parent->cpos_y+obj->parent->csize_y-obj->panel->pos_y)+0.1);
			
			if ((obj->panel->pos_x < obj->parent->cpos_x) || (obj->panel->pos_y < obj->parent->cpos_y)) obj->panel->size_x = 0.1;
			
			
		}
		
		if ((obj->stype == 2) || (obj->stype == 8))
		{
			obj->text->size_x = maxv(1,minv(bmap_width(obj->panel->bmap)-obj->tpos_x/2,obj->parent->cpos_x+obj->parent->csize_x-obj->text->pos_x)+1);
			obj->text->size_y = maxv(1,minv(bmap_height(obj->panel->bmap)-obj->tpos_y,obj->parent->cpos_y+obj->parent->csize_y-obj->text->pos_y)+1);
			
			switch(obj->parent->stype)
			{
				case 1:
				if ((obj->panel->pos_x < obj->parent->cpos_x) || (obj->panel->pos_y < obj->parent->cpos_y)) obj->text->size_x = 1;
				break;
				case 9: case 10:
				if ((obj->text->pos_x < obj->parent->parent->cpos_x) || (obj->text->pos_y < obj->parent->parent->cpos_y)) obj->text->size_x = 1;
				break;
			}
		}
		else if((obj->stype == 4) || (obj->stype == 17))
		{
			if(obj->size_x != 0) ((LBG_TEXT*)(obj))->text->size_x = maxv(1,minv(obj->size_x,obj->parent->cpos_x + obj->parent->csize_x - ((LBG_TEXT*)(obj))->text->pos_x)+1);
			else ((LBG_TEXT*)(obj))->text->size_x = maxv(1,obj->parent->cpos_x + obj->parent->csize_x - ((LBG_TEXT*)(obj))->text->pos_x+1);
			
			if(obj->size_y != 0) ((LBG_TEXT*)(obj))->text->size_y = maxv(1,minv(obj->size_y,obj->parent->cpos_y + obj->parent->csize_y - ((LBG_TEXT*)(obj))->text->pos_y)+1);
			else ((LBG_TEXT*)(obj))->text->size_y = maxv(1,obj->parent->cpos_y + obj->parent->csize_y - ((LBG_TEXT*)(obj))->text->pos_y+1);
			
			if ((((LBG_TEXT*)(obj))->text->pos_x < ((LBG_TEXT*)(obj))->parent->cpos_x) || (((LBG_TEXT*)(obj))->text->pos_y < ((LBG_TEXT*)(obj))->parent->cpos_y)) ((LBG_TEXT*)(obj))->text->size_x = 1;
		}
		else if(obj->stype == 6)
		{
			obj->text->size_x = maxv(1,minv(65535,obj->parent->cpos_x+obj->parent->csize_x-obj->text->pos_x)+1);
			obj->text->size_y = maxv(1,minv(65535,obj->parent->cpos_y+obj->parent->csize_y-obj->text->pos_y)+1);
			if ((obj->text->pos_x < obj->parent->cpos_x) || (obj->text->pos_y < obj->parent->cpos_y)) obj->text->size_x = 1;
		}
		else if (obj->stype == 18)
		{
			obj->text->size_x = maxv(1,minv(bmap_width(obj->panel->bmap)-obj->tpos_x*2,obj->parent->cpos_x+obj->parent->csize_x-obj->text->pos_x)+1);
			obj->text->size_y = maxv(1,minv(bmap_height(obj->panel->bmap)-obj->tpos_y,obj->parent->cpos_y+obj->parent->csize_y-obj->text->pos_y)+1);
			
			((LBG_EDITBOX*)(obj))->cursor->size_x = maxv(1,minv(65535,obj->parent->cpos_x+obj->parent->csize_x-((LBG_EDITBOX*)(obj))->cursor->pos_x)+1);
			((LBG_EDITBOX*)(obj))->cursor->size_y = maxv(1,minv(65535,obj->parent->cpos_y+obj->parent->csize_y-((LBG_EDITBOX*)(obj))->cursor->pos_y)+1);
		}
		
		
		if(obj->stype == 11)
		{
			((LBG_SLIDER*)(obj))->knob->size_x = maxv(0.1,minv(bmap_width(((LBG_SLIDER*)(obj))->knob->bmap),((LBG_SLIDER*)(obj))->parent->cpos_x+((LBG_SLIDER*)(obj))->parent->csize_x-((LBG_SLIDER*)(obj))->knob->pos_x)+0.1);
			((LBG_SLIDER*)(obj))->knob->size_y = maxv(0.1,minv(bmap_height(((LBG_SLIDER*)(obj))->knob->bmap),((LBG_SLIDER*)(obj))->parent->cpos_y+((LBG_SLIDER*)(obj))->parent->csize_y-((LBG_SLIDER*)(obj))->knob->pos_y)+0.1);
			if ((obj->panel->pos_x < obj->parent->cpos_x) || (obj->panel->pos_y < obj->parent->cpos_y)) ((LBG_SLIDER*)(obj))->knob->size_x = 0.1;
		}
		
		if(obj->stype == 14)
		{
			obj->panel->size_x = maxv(0.1,minv(((LBG_LISTBOX*)(obj->parent))->lsize_x,obj->parent->panel->pos_x+obj->parent->panel->size_x-obj->panel->pos_x)+0.1);
			obj->panel->size_y = maxv(0.1,minv(minv(obj->size_y,((LBG_LISTBOX*)(obj->parent))->lpos_y+((LBG_LISTBOX*)(obj->parent))->lsize_y-obj->panel->pos_y),obj->parent->panel->pos_y+obj->parent->panel->size_y-obj->panel->pos_y)+0.1);
			
			
			if((obj->parent->flags & LFi_RIGHTCLICK) || (obj->parent->flags & LFi_COMBOBOX))
			{
				obj->panel->size_x = obj->size_x;
				obj->panel->size_y = obj->size_y;
			}
			
			
			if ((obj->panel->pos_x < ((LBG_LISTBOX*)(obj->parent))->lpos_x) || (obj->panel->pos_y < ((LBG_LISTBOX*)(obj->parent))->lpos_y)) obj->panel->size_x = 0.1;
			
			
			
			obj->text->size_x = obj->panel->size_x - ((LBG_LISTBOX*)(obj->parent))->tpos_x;
			obj->text->size_y = obj->panel->size_y - ((LBG_LISTBOX*)(obj->parent))->tpos_y;
		}
	}
	
}


LBG_WINDOW* LBG_search_disablegui ();
int LBG_find_window_in_parents (LBG_WINDOW* obj,LBG_WINDOW* win);
int LBG_not_disabled_by_disablegui (LBG_WINDOW* obj)
{
	LBG_WINDOW* win = LBG_search_disablegui ();
	if(!win) return 1;
	return LBG_find_window_in_parents(obj,win);
}

LBG_WINDOW* LBG_search_disableparent (LBG_WINDOW* obj);
int LBG_not_disabled_by_disableparent (LBG_WINDOW* obj)
{
	LBG_WINDOW* win = LBG_search_disableparent (obj);
	if(!win) return 1;
	if(win == obj) return 1;
	return LBG_find_window_in_parents(obj,win);
}

int LBG_no_parent_disabled (LBG_WINDOW* obj)
{
	if(!obj) return 1;
	while(obj)
	{
		if(obj->flags & WF_DISABLED) return 0;
		obj = obj->parent;
	}
	return 1;
}


int LBG_not_disabled_by_disableflag (LBG_WINDOW* obj)
{
	if(LBG_flags & LBGUI_DISABLED) return 0;
	return (LBG_not_disabled_by_disablegui(obj) && LBG_not_disabled_by_disableparent(obj) && LBG_no_parent_disabled(obj));
}


#define LBG_object_upate_pos LBG_object_update_pos
#define LBG_object_upate_size LBG_object_update_size


LBG_INFOBOX* LBG_destroy_infobox (LBG_INFOBOX* ifo);
void LBG_object_destroy_infoboxes (LBG_WINDOW* obj)
{
	LBG_INFOBOX* ifo = LBG_INFOBOX_FIRST;
	ifo = LBG_INFOBOX_FIRST;
	while(ifo)
	{
		if(ifo->target == obj)
		{
			if (!(ifo->flags & IF_DONTDESTROY)) ifo = LBG_destroy_infobox (ifo);
			else
			{
				ifo->target = 0;
				ifo = ifo->next;
			}
		}
		else ifo = ifo->next;
	}
}

LBG_RIGHTCLICK* LBG_destroy_rightclick (LBG_RIGHTCLICK* rcl);
void LBG_object_destroy_rightclicks (LBG_WINDOW* obj)
{
	LBG_RIGHTCLICK* rcl = LBG_RIGHTCLICK_FIRST;
	rcl = LBG_RIGHTCLICK_FIRST;
	while(rcl)
	{
		if(rcl->target == obj)
		{
			rcl = LBG_destroy_rightclick (rcl);
		}
		else rcl = rcl->next;
	}
}